Index: palm/trunk/SCRIPTS/palmbuild
===================================================================
--- palm/trunk/SCRIPTS/palmbuild	(revision 3724)
+++ palm/trunk/SCRIPTS/palmbuild	(revision 3725)
@@ -27,4 +27,8 @@
 # -----------------
 # $Id$
+# ssh-calls for compilations on remote systems modified to avoid output
+# of login messages on specific systems changed again (reverted as before r3549)
+# 
+# 3549 2018-11-21 15:44:44Z raasch
 # ssh-calls for compilations on remote systems modified to avoid output
 # of login messages on specific systems
@@ -571,6 +575,6 @@
        fi
        make_call_string="make  -f Makefile_utilities  $make_options  F90=$compiler_name  F90_SER=$compiler_name_ser  COPT=\"$cpp_options\"  F90FLAGS=\"$compiler_options\"  LDFLAGS=\"$linker_options\" "
-       echo "$login_init_cmd $module_commands cd ${make_depository}; echo $make_call_string > LAST_MAKE_CALL; chmod u+x LAST_MAKE_CALL; $make_call_string; [[ \$? != 0 ]] && echo MAKE_ERROR" | ssh  -q  $ssh_key  ${remote_username}@${remote_ip} 2>/dev/null | tee ${configuration_identifier}_last_make_protocol
-###       ssh  -q  $ssh_key  ${remote_username}@${remote_ip}  "$login_init_cmd $module_commands cd ${make_depository}; echo $make_call_string > LAST_MAKE_CALL; chmod u+x LAST_MAKE_CALL; $make_call_string; [[ \$? != 0 ]] && echo MAKE_ERROR"  2>&1 | tee ${configuration_identifier}_last_make_protocol
+###       echo "$login_init_cmd $module_commands cd ${make_depository}; echo $make_call_string > LAST_MAKE_CALL; chmod u+x LAST_MAKE_CALL; $make_call_string; [[ \$? != 0 ]] && echo MAKE_ERROR" | ssh  -q  $ssh_key  ${remote_username}@${remote_ip} 2>/dev/null | tee ${configuration_identifier}_last_make_protocol
+       ssh  -q  $ssh_key  ${remote_username}@${remote_ip}  "$login_init_cmd $module_commands cd ${make_depository}; echo $make_call_string > LAST_MAKE_CALL; chmod u+x LAST_MAKE_CALL; $make_call_string; [[ \$? != 0 ]] && echo MAKE_ERROR"  2>&1 | tee ${configuration_identifier}_last_make_protocol
 
        if [[ $(grep -c MAKE_ERROR ${configuration_identifier}_last_make_protocol) != 0 ]]
@@ -611,6 +615,6 @@
        fi
        make_call_string="make  $make_options  PROG=$program_name  F90=$compiler_name  COPT=\"$cpp_options\"  F90FLAGS=\"$compiler_options\"  LDFLAGS=\"$linker_options\" "
-       echo "$login_init_cmd $module_commands cd ${make_depository}; echo $make_call_string > LAST_MAKE_CALL; chmod u+x LAST_MAKE_CALL; $make_call_string; [[ \$? != 0 ]] && echo MAKE_ERROR" | ssh  -q  $ssh_key  ${remote_username}@${remote_ip} 2>&1 | tee ${configuration_identifier}_last_make_protocol
-###       ssh  -q  $ssh_key  ${remote_username}@${remote_ip}  "$login_init_cmd $module_commands cd ${make_depository}; echo $make_call_string > LAST_MAKE_CALL; chmod u+x LAST_MAKE_CALL; $make_call_string; [[ \$? != 0 ]] && echo MAKE_ERROR"  2>&1 | tee ${configuration_identifier}_last_make_protocol
+###       echo "$login_init_cmd $module_commands cd ${make_depository}; echo $make_call_string > LAST_MAKE_CALL; chmod u+x LAST_MAKE_CALL; $make_call_string; [[ \$? != 0 ]] && echo MAKE_ERROR" | ssh  -q  $ssh_key  ${remote_username}@${remote_ip} 2>&1 | tee ${configuration_identifier}_last_make_protocol
+       ssh  -q  $ssh_key  ${remote_username}@${remote_ip}  "$login_init_cmd $module_commands cd ${make_depository}; echo $make_call_string > LAST_MAKE_CALL; chmod u+x LAST_MAKE_CALL; $make_call_string; [[ \$? != 0 ]] && echo MAKE_ERROR"  2>&1 | tee ${configuration_identifier}_last_make_protocol
 
        if [[ $(grep -c MAKE_ERROR ${configuration_identifier}_last_make_protocol) != 0 ]]
Index: palm/trunk/SCRIPTS/palmrun
===================================================================
--- palm/trunk/SCRIPTS/palmrun	(revision 3724)
+++ palm/trunk/SCRIPTS/palmrun	(revision 3725)
@@ -27,4 +27,7 @@
 # -----------------
 # $Id$
+# error messages for failed restarts extended
+# 
+# 3682 2019-01-18 17:01:54Z knoop
 # ssh-call for submitting batch jobs on remote systems modified again to avoid output
 # of login messages on specific systems
@@ -2799,5 +2802,5 @@
 
           # CHECK, IF RESTART JOB HAS BEEN STARTED
-       if [[ $( grep -c "+++ palmrun killed"  palmrun_restart.log ) != 0 ]]
+       if [[ $( grep -c "+++ palmrun crashed"  palmrun_restart.log ) != 0 ]]
        then
           printf "\n$dashes\n  +++ creating restart run failed \n"
@@ -2805,4 +2808,10 @@
           rm  palmrun_restart.log
           exit
+       elif [[ $( grep -c "*** palmrun finished"  palmrun_restart.log ) != 1 ]]
+       then
+          printf "\n$dashes\n  +++ creating restart run failed, probably due to network problems\n"
+          locat=create_restart
+          rm  palmrun_restart.log
+          exit       
        else
           printf "\n$dashes\n  *** restart run initiated \n"
Index: palm/trunk/SOURCE/buoyancy.f90
===================================================================
--- palm/trunk/SOURCE/buoyancy.f90	(revision 3724)
+++ palm/trunk/SOURCE/buoyancy.f90	(revision 3725)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! unused variables removed
+! 
+! 3655 2019-01-07 16:51:22Z knoop
 ! nopointer option removed
 ! 
@@ -160,6 +163,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxlg, nxlu, nxr, nxrg, nyn, nyng, nys, nysg, nzb,       &
-                  nzt
+           ONLY:  nxl, nxlu, nxr, nyn, nys, nzb, nzt
 
 
@@ -251,5 +253,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxlg, nxrg, nyng, nysg, nzb, nzt
+           ONLY:  nzb, nzt
 
        IMPLICIT NONE
Index: palm/trunk/SOURCE/data_log.f90
===================================================================
--- palm/trunk/SOURCE/data_log.f90	(revision 3724)
+++ palm/trunk/SOURCE/data_log.f90	(revision 3725)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! preprocessor directives removed to avoid compiler warnings
+! 
+! 3655 2019-01-07 16:51:22Z knoop
 ! Corrected "Former revisions" section
 ! 
@@ -61,6 +64,4 @@
  SUBROUTINE data_log( array, i1, i2, j1, j2, k1, k2 )
  
-#if defined( __logging )
-
     USE control_parameters,                                                    &
         ONLY:  log_message, simulated_time
@@ -98,5 +99,4 @@
     WRITE ( 20 )  array
 
-#endif
  END SUBROUTINE data_log
 
@@ -110,6 +110,4 @@
  
  SUBROUTINE data_log_2d( array, i1, i2, j1, j2)
-
-#if defined( __logging )
 
     USE control_parameters,                                                    &
@@ -146,5 +144,4 @@
     WRITE ( 20 )  array
 
-#endif
  END SUBROUTINE data_log_2d
 
@@ -158,6 +155,4 @@
  
  SUBROUTINE data_log_2d_int( array, i1, i2, j1, j2)
-
-#if defined( __logging )
 
     USE control_parameters,                                                    &
@@ -194,4 +189,3 @@
     WRITE ( 20 )  array
 
-#endif
  END SUBROUTINE data_log_2d_int
Index: palm/trunk/SOURCE/gust_mod.f90
===================================================================
--- palm/trunk/SOURCE/gust_mod.f90	(revision 3724)
+++ palm/trunk/SOURCE/gust_mod.f90	(revision 3725)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! dummy statement modified to avoid compiler warnings about unused variables
+! 
+! 3685 2019-01-21 01:02:11Z knoop
 ! Some interface calls moved to module_interface + cleanup
 ! 
@@ -445,5 +448,7 @@
 !
 !--    Next line is just to avoid compiler warnings about unused variables. You may remove it.
-       IF ( found .AND. two_d )  idum = av + LEN( variable ) + LEN( grid ) + local_pf(nxl,nys,nzb_do) + fill_value
+       IF ( found .AND. two_d )  THEN
+          idum = av + LEN( variable ) + LEN( grid // mode ) + local_pf(nxl,nys,nzb_do) + fill_value
+       ENDIF
 
     END SUBROUTINE gust_data_output_2d
Index: palm/trunk/SOURCE/poismg_mod.f90
===================================================================
--- palm/trunk/SOURCE/poismg_mod.f90	(revision 3724)
+++ palm/trunk/SOURCE/poismg_mod.f90	(revision 3725)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! unused subroutine removed
+! 
+! 3655 2019-01-07 16:51:22Z knoop
 ! unnecessary check eliminated
 ! 
@@ -143,5 +146,5 @@
     INTERFACE sort_k_to_even_odd_blocks
        MODULE PROCEDURE sort_k_to_even_odd_blocks
-       MODULE PROCEDURE sort_k_to_even_odd_blocks_int
+!       MODULE PROCEDURE sort_k_to_even_odd_blocks_int
        MODULE PROCEDURE sort_k_to_even_odd_blocks_1d
     END INTERFACE sort_k_to_even_odd_blocks
@@ -1152,58 +1155,58 @@
 !> Version for 2D-INTEGER arrays
 !------------------------------------------------------------------------------!
-    SUBROUTINE sort_k_to_even_odd_blocks_int( i_mg , glevel )
-
-
-       USE indices,                                                            &
-           ONLY:  nxl_mg, nxr_mg, nys_mg, nyn_mg, nzb, nzt_mg
-
-       IMPLICIT NONE
-
-       INTEGER(iwp), INTENT(IN) ::  glevel  !< grid level
-
-       INTEGER(iwp), DIMENSION(nzb:nzt_mg(glevel)+1,                           &
-                               nys_mg(glevel)-1:nyn_mg(glevel)+1,              &
-                               nxl_mg(glevel)-1:nxr_mg(glevel)+1) ::           &
-                                    i_mg    !< array to be sorted 
+!    SUBROUTINE sort_k_to_even_odd_blocks_int( i_mg , glevel )
+!
+!
+!       USE indices,                                                            &
+!           ONLY:  nxl_mg, nxr_mg, nys_mg, nyn_mg, nzb, nzt_mg
+!
+!       IMPLICIT NONE
+!
+!       INTEGER(iwp), INTENT(IN) ::  glevel  !< grid level
+!
+!       INTEGER(iwp), DIMENSION(nzb:nzt_mg(glevel)+1,                           &
+!                               nys_mg(glevel)-1:nyn_mg(glevel)+1,              &
+!                               nxl_mg(glevel)-1:nxr_mg(glevel)+1) ::           &
+!                                    i_mg    !< array to be sorted
 !
 !--    Local variables
-       INTEGER(iwp) :: i        !< index variabel along x
-       INTEGER(iwp) :: j        !< index variable along y
-       INTEGER(iwp) :: k        !< index variable along z
-       INTEGER(iwp) :: l        !< grid level 
-       INTEGER(iwp) :: ind      !< index variable along z
-       INTEGER(iwp),DIMENSION(nzb:nzt_mg(glevel)+1) ::  tmp  !< temporary odd-even sorted array
-
-
-       CALL cpu_log( log_point_s(52), 'sort_k_to_even_odd', 'start' )
-
-       l = glevel
-       ind_even_odd = even_odd_level(l)
-
-       DO  i = nxl_mg(l)-1, nxr_mg(l)+1
-          DO  j = nys_mg(l)-1, nyn_mg(l)+1
-
+!       INTEGER(iwp) :: i        !< index variabel along x
+!       INTEGER(iwp) :: j        !< index variable along y
+!       INTEGER(iwp) :: k        !< index variable along z
+!       INTEGER(iwp) :: l        !< grid level
+!       INTEGER(iwp) :: ind      !< index variable along z
+!       INTEGER(iwp),DIMENSION(nzb:nzt_mg(glevel)+1) ::  tmp  !< temporary odd-even sorted array
+!
+!
+!       CALL cpu_log( log_point_s(52), 'sort_k_to_even_odd', 'start' )
+!
+!       l = glevel
+!       ind_even_odd = even_odd_level(l)
+!
+!       DO  i = nxl_mg(l)-1, nxr_mg(l)+1
+!          DO  j = nys_mg(l)-1, nyn_mg(l)+1
+!
 !
 !--          Sort the data with even k index
-             ind = nzb-1
-             DO  k = nzb, nzt_mg(l), 2
-                ind = ind + 1
-                tmp(ind) = i_mg(k,j,i)
-             ENDDO
+!             ind = nzb-1
+!             DO  k = nzb, nzt_mg(l), 2
+!                ind = ind + 1
+!                tmp(ind) = i_mg(k,j,i)
+!             ENDDO
 !
 !--          Sort the data with odd k index
-             DO  k = nzb+1, nzt_mg(l)+1, 2
-                ind = ind + 1
-                tmp(ind) = i_mg(k,j,i)
-             ENDDO
-
-             i_mg(:,j,i) = tmp
-
-          ENDDO
-       ENDDO
-
-       CALL cpu_log( log_point_s(52), 'sort_k_to_even_odd', 'stop' )
-
-    END SUBROUTINE sort_k_to_even_odd_blocks_int
+!             DO  k = nzb+1, nzt_mg(l)+1, 2
+!                ind = ind + 1
+!                tmp(ind) = i_mg(k,j,i)
+!             ENDDO
+!
+!             i_mg(:,j,i) = tmp
+!
+!          ENDDO
+!       ENDDO
+!
+!       CALL cpu_log( log_point_s(52), 'sort_k_to_even_odd', 'stop' )
+!
+!    END SUBROUTINE sort_k_to_even_odd_blocks_int
 
 
Index: palm/trunk/SOURCE/temperton_fft_mod.f90
===================================================================
--- palm/trunk/SOURCE/temperton_fft_mod.f90	(revision 3724)
+++ palm/trunk/SOURCE/temperton_fft_mod.f90	(revision 3725)
@@ -9,4 +9,7 @@
 ! -----------------
 ! $Id$
+! GOTO statements replaced, file re-formatted corresponding to coding standards
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -25,5 +28,4 @@
 ! Module renamed
 ! 
-! 
 ! 1682 2015-10-07 23:56:08Z knoop
 ! Code annotations made doxygen readable 
@@ -70,5 +72,5 @@
 ! Description:
 ! ------------
-!> Calls fortran-versions of fft's.
+!> Calls Fortran-versions of fft's.
 !> 
 !> Method:
@@ -115,5 +117,5 @@
 !> dimension a(n),work(n),trigs(n),ifax(1)
 !------------------------------------------------------------------------------!
-  SUBROUTINE fft991cy(a,work,trigs,ifax,inc,jump,n,lot,isign)
+ SUBROUTINE fft991cy( a, work, trigs, ifax, inc, jump, n, lot, isign )
 
     USE kinds
@@ -121,5 +123,4 @@
     IMPLICIT NONE
 
-    !  Scalar arguments 
     INTEGER(iwp) ::  inc   !< 
     INTEGER(iwp) ::  isign !< 
@@ -128,5 +129,4 @@
     INTEGER(iwp) ::  n     !< 
 
-    !  Array arguments 
     REAL(wp)     ::  a(*)     !< 
     REAL(wp)     ::  trigs(*) !< 
@@ -134,5 +134,4 @@
     INTEGER(iwp) ::  ifax(*)  !< 
 
-    !  Local scalars: 
     INTEGER(iwp) ::  i      !< 
     INTEGER(iwp) ::  ia     !< 
@@ -156,177 +155,185 @@
     INTEGER(iwp) ::  nx     !< 
 
-    !  Intrinsic functions 
-!    INTRINSIC MOD
-
-
-    !  Executable statements 
-
-    IF (ifax(10)/=n) CALL set99(trigs,ifax,n)
+
+    IF ( ifax(10) /= n )  CALL set99( trigs, ifax, n )
     nfax = ifax(1)
-    nx = n + 1
-    IF (MOD(n,2)==1) nx = n
-    nblox = 1 + (lot-1)/nfft
-    nvex = lot - (nblox-1)*nfft
-    IF (isign==-1) GO TO 50
-
-    ! isign=+1, spectral to gridpoint transform
-
-    istart = 1
-    DO nb = 1, nblox
-       ia = istart
-       i = istart
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO j = 1, nvex
-          a(i+inc) = 0.5_wp*a(i)
-          i = i + jump
-       END DO
-       IF (MOD(n,2)==1) GO TO 10
-       i = istart + n*inc
-       DO j = 1, nvex
-          a(i) = 0.5_wp*a(i)
-          i = i + jump
-       END DO
-10     CONTINUE
-       ia = istart + inc
-       la = 1
-       igo = + 1
-
-       DO k = 1, nfax
-          ifac = ifax(k+1)
-          ierr = -1
-          IF (igo==-1) GO TO 20
-          CALL rpassm(a(ia),a(ia+la*inc),work(1),work(ifac*la+1),trigs,inc,1, &
-               &          jump,nx,nvex,n,ifac,la,ierr)
-          GO TO 30
-20        CONTINUE
-          CALL rpassm(work(1),work(la+1),a(ia),a(ia+ifac*la*inc),trigs,1,inc,nx, &
-               &          jump,nvex,n,ifac,la,ierr)
-30        CONTINUE
-          IF (ierr/=0) GO TO 100
-          la = ifac*la
-          igo = -igo
+    nx   = n + 1
+    IF ( MOD(n,2) == 1 )  nx = n
+    nblox = 1 + (lot-1) / nfft
+    nvex = lot - (nblox-1) * nfft
+
+
+    IF ( isign == 1 )  THEN
+!
+!--    Backward fft: spectral to gridpoint transform
+
+       istart = 1
+       DO  nb = 1, nblox
+
           ia = istart
-       END DO
-
-       ! If necessary, copy results back to a
-
-       IF (MOD(nfax,2)==0) GO TO 40
-       ibase = 1
-       jbase = ia
-       DO jj = 1, nvex
-          i = ibase
-          j = jbase
-          DO ii = 1, n
-             a(j) = work(i)
-             i = i + 1
-             j = j + inc
-          END DO
-          ibase = ibase + nx
-          jbase = jbase + jump
-       END DO
-40     CONTINUE
-
-       ! Fill in zeros at end
-
-       ix = istart + n*inc
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO j = 1, nvex
-          a(ix) = 0.0_wp
-          a(ix+inc) = 0.0_wp
-          ix = ix + jump
-       END DO
-
-       istart = istart + nvex*jump
-       nvex = nfft
-    END DO
-    RETURN
-
-    ! isign=-1, gridpoint to spectral transform
-
-50  CONTINUE
-    istart = 1
-    DO nb = 1, nblox
-       ia = istart
-       la = n
-       igo = + 1
-
-       DO k = 1, nfax
-          ifac = ifax(nfax+2-k)
-          la = la/ifac
-          ierr = -1
-          IF (igo==-1) GO TO 60
-          CALL qpassm(a(ia),a(ia+ifac*la*inc),work(1),work(la+1),trigs,inc,1, &
-               &          jump,nx,nvex,n,ifac,la,ierr)
-          GO TO 70
-60        CONTINUE
-          CALL qpassm(work(1),work(ifac*la+1),a(ia),a(ia+la*inc),trigs,1,inc,nx, &
-               &          jump,nvex,n,ifac,la,ierr)
-70        CONTINUE
-          IF (ierr/=0) GO TO 100
-          igo = -igo
+          i = istart
+          !DIR$ IVDEP
+          !CDIR NODEP
+          !OCL NOVREC
+          DO  j = 1, nvex
+             a(i+inc) = 0.5_wp * a(i)
+             i = i + jump
+          ENDDO
+          IF ( MOD(n,2) /= 1 )  THEN
+             i = istart + n * inc
+             DO  j = 1, nvex
+                a(i) = 0.5_wp * a(i)
+                i = i + jump
+             ENDDO
+          ENDIF
           ia = istart + inc
-       END DO
-
-       ! If necessary, copy results back to a
-
-       IF (MOD(nfax,2)==0) GO TO 80
-       ibase = 1
-       jbase = ia
-       DO jj = 1, nvex
-          i = ibase
-          j = jbase
-          DO ii = 1, n
-             a(j) = work(i)
-             i = i + 1
-             j = j + inc
-          END DO
-          ibase = ibase + nx
-          jbase = jbase + jump
-       END DO
-80     CONTINUE
-
-       ! Shift a(0) & fill in zero imag parts
-
-       ix = istart
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO j = 1, nvex
-          a(ix) = a(ix+inc)
-          a(ix+inc) = 0.0_wp
-          ix = ix + jump
-       END DO
-       IF (MOD(n,2)==1) GO TO 90
-       iz = istart + (n+1)*inc
-       DO j = 1, nvex
-          a(iz) = 0.0_wp
-          iz = iz + jump
-       END DO
-90     CONTINUE
-
-       istart = istart + nvex*jump
-       nvex = nfft
-    END DO
-    RETURN
-
-    ! Error messages
-
-100 CONTINUE
-
-    SELECT CASE (ierr)
-    CASE (:-1)
-       WRITE (nout,'(A,I5,A)') ' Vector length =',nvex,', greater than nfft'
-    CASE (0)
-       WRITE (nout,'(A,I3,A)') ' Factor =',ifac,', not catered for'
-    CASE (1:)
-       WRITE (nout,'(A,I3,A)') ' Factor =',ifac,', only catered for if la*ifac=n'
-    END SELECT
-
-    RETURN
-  END SUBROUTINE fft991cy
+          la = 1
+          igo = + 1
+
+          DO  k = 1, nfax
+
+             ifac = ifax(k+1)
+             ierr = -1
+             IF ( igo /= -1 )  THEN
+                CALL rpassm( a(ia), a(ia+la*inc), work(1), work(ifac*la+1), trigs, inc, 1, jump,   &
+                             nx, nvex, n, ifac, la, ierr )
+             ELSE
+                CALL rpassm( work(1), work(la+1), a(ia), a(ia+ifac*la*inc), trigs, 1, inc, nx,     &
+                             jump, nvex, n, ifac, la, ierr )
+             ENDIF
+!
+!--          Following messages shouldn't appear in PALM applications
+             IF ( ierr /= 0 )  THEN
+                SELECT CASE (ierr)
+                   CASE (:-1)
+                      WRITE (nout,'(A,I5,A)') ' Vector length =',nvex,', greater than nfft'
+                   CASE (0)
+                      WRITE (nout,'(A,I3,A)') ' Factor =',ifac,', not catered for'
+                   CASE (1:)
+                      WRITE (nout,'(A,I3,A)') ' Factor =',ifac,', only catered for if la*ifac=n'
+                END SELECT
+                RETURN
+             ENDIF
+
+             la  = ifac * la
+             igo = -igo
+             ia  = istart
+
+          ENDDO
+!
+!--       If necessary, copy results back to a
+          IF ( MOD(nfax,2) /= 0 )  THEN
+             ibase = 1
+             jbase = ia
+             DO  jj = 1, nvex
+                i = ibase
+                j = jbase
+                DO  ii = 1, n
+                   a(j) = work(i)
+                   i = i + 1
+                   j = j + inc
+                ENDDO
+                ibase = ibase + nx
+                jbase = jbase + jump
+             ENDDO
+          ENDIF
+!
+!--       Fill in zeros at end
+          ix = istart + n*inc
+          !DIR$ IVDEP
+          !CDIR NODEP
+          !OCL NOVREC
+          DO  j = 1, nvex
+             a(ix) = 0.0_wp
+             a(ix+inc) = 0.0_wp
+             ix = ix + jump
+          ENDDO
+          istart = istart + nvex*jump
+          nvex = nfft
+
+       ENDDO
+
+    ELSEIF ( isign == -1 )  THEN
+!
+!--    Forward fft: gridpoint to spectral transform
+       istart = 1
+       DO  nb = 1, nblox
+          ia  = istart
+          la  = n
+          igo = + 1
+
+          DO  k = 1, nfax
+
+             ifac = ifax(nfax+2-k)
+             la = la / ifac
+             ierr = -1
+             IF ( igo /= -1 )  THEN
+                CALL qpassm( a(ia), a(ia+ifac*la*inc), work(1), work(la+1), trigs, inc, 1, jump,   &
+                             nx, nvex, n, ifac, la, ierr )
+             ELSE
+                CALL qpassm( work(1), work(ifac*la+1), a(ia), a(ia+la*inc), trigs, 1, inc, nx,     &
+                             jump, nvex, n, ifac, la, ierr )
+             ENDIF
+!
+!--          Following messages shouldn't appear in PALM applications
+             IF ( ierr /= 0 )  THEN
+                SELECT CASE (ierr)
+                   CASE (:-1)
+                      WRITE (nout,'(A,I5,A)') ' Vector length =',nvex,', greater than nfft'
+                   CASE (0)
+                      WRITE (nout,'(A,I3,A)') ' Factor =',ifac,', not catered for'
+                   CASE (1:)
+                      WRITE (nout,'(A,I3,A)') ' Factor =',ifac,', only catered for if la*ifac=n'
+                END SELECT
+                RETURN
+             ENDIF
+
+             igo = -igo
+             ia = istart + inc
+
+          ENDDO
+!
+!--       If necessary, copy results back to a
+          IF ( MOD(nfax,2) /= 0 )  THEN
+             ibase = 1
+             jbase = ia
+             DO  jj = 1, nvex
+                i = ibase
+                j = jbase
+                DO  ii = 1, n
+                   a(j) = work(i)
+                   i = i + 1
+                   j = j + inc
+                ENDDO
+                ibase = ibase + nx
+                jbase = jbase + jump
+             ENDDO
+          ENDIF
+!
+!--       Shift a(0) and fill in zero imag parts
+          ix = istart
+          !DIR$ IVDEP
+          !CDIR NODEP
+          !OCL NOVREC
+          DO  j = 1, nvex
+             a(ix) = a(ix+inc)
+             a(ix+inc) = 0.0_wp
+             ix = ix + jump
+          ENDDO
+          IF ( MOD(n,2) /= 1 )  THEN
+             iz = istart + (n+1) * inc
+             DO  j = 1, nvex
+                a(iz) = 0.0_wp
+                iz = iz + jump
+             ENDDO
+          ENDIF
+          istart = istart + nvex * jump
+          nvex = nfft
+
+       ENDDO
+
+    ENDIF
+
+ END SUBROUTINE fft991cy
 
 !------------------------------------------------------------------------------!
@@ -357,5 +364,5 @@
 !>         3 - ifac only catered for if la=n/ifac
 !------------------------------------------------------------------------------!
-  SUBROUTINE qpassm(a,b,c,d,trigs,inc1,inc2,inc3,inc4,lot,n,ifac,la,ierr)
+ SUBROUTINE qpassm( a, b, c, d, trigs, inc1, inc2, inc3, inc4, lot, n, ifac, la, ierr )
 
     USE kinds
@@ -363,5 +370,4 @@
     IMPLICIT NONE 
 
-    !  Scalar arguments 
     INTEGER(iwp) ::  ierr !< 
     INTEGER(iwp) ::  ifac !< 
@@ -374,6 +380,6 @@
     INTEGER(iwp) ::  n    !< 
 
-    !  Array arguments 
-    ! REAL :: a(n),b(n),c(n),d(n),trigs(n)
+!
+!-- Arrays are dimensioned with n
     REAL(wp) ::  a(*)     !< 
     REAL(wp) ::  b(*)     !< 
@@ -382,5 +388,4 @@
     REAL(wp) ::  trigs(*) !<
  
-    !  Local scalars: 
     REAL(wp) ::  a0     !< 
     REAL(wp) ::  a1     !< 
@@ -430,5 +435,4 @@
     INTEGER(iwp) ::  ia    !< 
     INTEGER(iwp) ::  ib    !< 
-    INTEGER(iwp) ::  ibad  !< 
     INTEGER(iwp) ::  ibase !< 
     INTEGER(iwp) ::  ic    !< 
